searchNodes=[{"ref":"Bureaucrat.html","title":"Bureaucrat","type":"module","doc":""},{"ref":"Bureaucrat.html#start/1","title":"Bureaucrat.start/1","type":"function","doc":""},{"ref":"Bureaucrat.html#start/2","title":"Bureaucrat.start/2","type":"function","doc":"Called when an application is started. This function is called when an application is started using Application.start/2 (and functions on top of that, such as Application.ensure_started/2). This function should start the top-level process of the application (which should be the top supervisor of the application&#39;s supervision tree if the application follows the OTP design principles around supervision). start_type defines how the application is started: :normal - used if the startup is a normal startup or if the application is distributed and is started on the current node because of a failover from another node and the application specification key :start_phases is :undefined. {:takeover, node} - used if the application is distributed and is started on the current node because of a failover on the node node. {:failover, node} - used if the application is distributed and is started on the current node because of a failover on node node, and the application specification key :start_phases is not :undefined. start_args are the arguments passed to the application in the :mod specification key (e.g., mod: {MyApp, [:my_args]}). This function should either return {:ok, pid} or {:ok, pid, state} if startup is successful. pid should be the PID of the top supervisor. state can be an arbitrary term, and if omitted will default to []; if the application is later stopped, state is passed to the stop/1 callback (see the documentation for the c:stop/1 callback for more information). use Application provides no default implementation for the start/2 callback. Callback implementation for Application.start/2."},{"ref":"Bureaucrat.ApiBlueprintWriter.html","title":"Bureaucrat.ApiBlueprintWriter","type":"module","doc":""},{"ref":"Bureaucrat.ApiBlueprintWriter.html#anchor/1","title":"Bureaucrat.ApiBlueprintWriter.anchor/1","type":"function","doc":""},{"ref":"Bureaucrat.ApiBlueprintWriter.html#controller_name/1","title":"Bureaucrat.ApiBlueprintWriter.controller_name/1","type":"function","doc":""},{"ref":"Bureaucrat.ApiBlueprintWriter.html#format_param/1","title":"Bureaucrat.ApiBlueprintWriter.format_param/1","type":"function","doc":""},{"ref":"Bureaucrat.ApiBlueprintWriter.html#format_request_body/1","title":"Bureaucrat.ApiBlueprintWriter.format_request_body/1","type":"function","doc":""},{"ref":"Bureaucrat.ApiBlueprintWriter.html#formatted_params/1","title":"Bureaucrat.ApiBlueprintWriter.formatted_params/1","type":"function","doc":""},{"ref":"Bureaucrat.ApiBlueprintWriter.html#indent_lines/2","title":"Bureaucrat.ApiBlueprintWriter.indent_lines/2","type":"function","doc":""},{"ref":"Bureaucrat.ApiBlueprintWriter.html#write/2","title":"Bureaucrat.ApiBlueprintWriter.write/2","type":"function","doc":""},{"ref":"Bureaucrat.Formatter.html","title":"Bureaucrat.Formatter","type":"module","doc":""},{"ref":"Bureaucrat.Formatter.html#child_spec/1","title":"Bureaucrat.Formatter.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Bureaucrat.Formatter.html#init/1","title":"Bureaucrat.Formatter.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Bureaucrat.Helpers.html","title":"Bureaucrat.Helpers","type":"module","doc":""},{"ref":"Bureaucrat.Helpers.html#doc/1","title":"Bureaucrat.Helpers.doc/1","type":"macro","doc":"Adds a conn to the generated documentation. The name of the test currently being executed will be used as a description for the example."},{"ref":"Bureaucrat.Helpers.html#doc/2","title":"Bureaucrat.Helpers.doc/2","type":"macro","doc":"Adds a conn to the generated documentation The description, and additional options can be passed in the second argument: Examples conn = conn() |&gt; get(&quot;/api/v1/products&quot;) |&gt; doc(&quot;List all products&quot;) conn = conn() |&gt; get(&quot;/api/v1/products&quot;) |&gt; doc(description: &quot;List all products&quot;, operation_id: &quot;list_products&quot;)"},{"ref":"Bureaucrat.Helpers.html#doc_broadcast_from/3","title":"Bureaucrat.Helpers.doc_broadcast_from/3","type":"macro","doc":""},{"ref":"Bureaucrat.Helpers.html#doc_broadcast_from!/3","title":"Bureaucrat.Helpers.doc_broadcast_from!/3","type":"macro","doc":""},{"ref":"Bureaucrat.Helpers.html#doc_push/2","title":"Bureaucrat.Helpers.doc_push/2","type":"macro","doc":"Adds a Phoenix.Socket.Message to the generated documentation. The name of the test currently being executed will be used as a description for the example."},{"ref":"Bureaucrat.Helpers.html#doc_push/3","title":"Bureaucrat.Helpers.doc_push/3","type":"macro","doc":""},{"ref":"Bureaucrat.Helpers.html#format_test_name/1","title":"Bureaucrat.Helpers.format_test_name/1","type":"function","doc":""},{"ref":"Bureaucrat.Helpers.html#group_title_for/2","title":"Bureaucrat.Helpers.group_title_for/2","type":"function","doc":""},{"ref":"Bureaucrat.Helpers.html#plug_doc/2","title":"Bureaucrat.Helpers.plug_doc/2","type":"function","doc":"Helper function for adding the phoenix_controller and phoenix_action keys to the private map of the request that&#39;s coming from the test modules. For example: test &quot;all items - unauthenticated&quot;, %{conn: conn} do conn |&gt; get(itempath(conn, :index)) |&gt; plugdoc(module: __MODULE, action: :index) |&gt; doc() |&gt; assert_unauthenticated() end The request from this test will never touch the controller that&#39;s being tested, because it is being piped through a plug that authenticates the user and redirects to another page. In this scenario, we use the plug_doc function."},{"ref":"Bureaucrat.JSON.html","title":"Bureaucrat.JSON","type":"module","doc":"Wrapper around the configured JSON library. The default is Poison, but it can be configured to e.g. Jason with: config :bureaucrat, :json_library, Jason"},{"ref":"Bureaucrat.JSON.html#decode/2","title":"Bureaucrat.JSON.decode/2","type":"function","doc":""},{"ref":"Bureaucrat.JSON.html#decode!/2","title":"Bureaucrat.JSON.decode!/2","type":"function","doc":""},{"ref":"Bureaucrat.JSON.html#encode/2","title":"Bureaucrat.JSON.encode/2","type":"function","doc":""},{"ref":"Bureaucrat.JSON.html#encode!/2","title":"Bureaucrat.JSON.encode!/2","type":"function","doc":""},{"ref":"Bureaucrat.MarkdownWriter.html","title":"Bureaucrat.MarkdownWriter","type":"module","doc":""},{"ref":"Bureaucrat.MarkdownWriter.html#format_body_params/1","title":"Bureaucrat.MarkdownWriter.format_body_params/1","type":"function","doc":""},{"ref":"Bureaucrat.MarkdownWriter.html#write/2","title":"Bureaucrat.MarkdownWriter.write/2","type":"function","doc":""},{"ref":"Bureaucrat.Recorder.html","title":"Bureaucrat.Recorder","type":"module","doc":""},{"ref":"Bureaucrat.Recorder.html#child_spec/1","title":"Bureaucrat.Recorder.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Bureaucrat.Recorder.html#doc/2","title":"Bureaucrat.Recorder.doc/2","type":"function","doc":""},{"ref":"Bureaucrat.Recorder.html#get_records/0","title":"Bureaucrat.Recorder.get_records/0","type":"function","doc":""},{"ref":"Bureaucrat.Recorder.html#init/1","title":"Bureaucrat.Recorder.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Bureaucrat.Recorder.html#start_link/0","title":"Bureaucrat.Recorder.start_link/0","type":"function","doc":""},{"ref":"Bureaucrat.SwaggerSlateMarkdownWriter.html","title":"Bureaucrat.SwaggerSlateMarkdownWriter","type":"module","doc":"This markdown writer integrates swagger information and outputs in a slate-friendly markdown format. It requires that the decoded swagger data be available via Application.get_env(:bureaucrat, :swagger), eg by passing it as an option to the Bureaucrat.start/1 function."},{"ref":"Bureaucrat.SwaggerSlateMarkdownWriter.html#find_operation_by_id/2","title":"Bureaucrat.SwaggerSlateMarkdownWriter.find_operation_by_id/2","type":"function","doc":"Find the details of an API operation in swagger by operationId"},{"ref":"Bureaucrat.SwaggerSlateMarkdownWriter.html#format_resp_body/1","title":"Bureaucrat.SwaggerSlateMarkdownWriter.format_resp_body/1","type":"function","doc":"Pretty-print a JSON response, handling body correctly"},{"ref":"Bureaucrat.SwaggerSlateMarkdownWriter.html#group_records/1","title":"Bureaucrat.SwaggerSlateMarkdownWriter.group_records/1","type":"function","doc":"Group a list of tagged records, first by tag, then by operation_id."},{"ref":"Bureaucrat.SwaggerSlateMarkdownWriter.html#resolve_schema_type/2","title":"Bureaucrat.SwaggerSlateMarkdownWriter.resolve_schema_type/2","type":"function","doc":""},{"ref":"Bureaucrat.SwaggerSlateMarkdownWriter.html#resolve_type/2","title":"Bureaucrat.SwaggerSlateMarkdownWriter.resolve_type/2","type":"function","doc":""},{"ref":"Bureaucrat.SwaggerSlateMarkdownWriter.html#schema_ref_to_link/1","title":"Bureaucrat.SwaggerSlateMarkdownWriter.schema_ref_to_link/1","type":"function","doc":""},{"ref":"Bureaucrat.SwaggerSlateMarkdownWriter.html#tag_record/2","title":"Bureaucrat.SwaggerSlateMarkdownWriter.tag_record/2","type":"function","doc":"Tag a single record with swagger tag and operation_id."},{"ref":"Bureaucrat.SwaggerSlateMarkdownWriter.html#tag_records/2","title":"Bureaucrat.SwaggerSlateMarkdownWriter.tag_records/2","type":"function","doc":"Populate each test record with private.swagger_tag and private.operation_id from swagger."},{"ref":"Bureaucrat.SwaggerSlateMarkdownWriter.html#write/2","title":"Bureaucrat.SwaggerSlateMarkdownWriter.write/2","type":"function","doc":"Writes a list of Plug.Conn records to the given file path. Each Conn should have request and response data populated, and the private.phoenix_controller, private.phoenix_action values set for linking to swagger."},{"ref":"Bureaucrat.SwaggerSlateMarkdownWriter.html#write_action/4","title":"Bureaucrat.SwaggerSlateMarkdownWriter.write_action/4","type":"function","doc":"Writes all examples of a given operation (Controller action) to file."},{"ref":"Bureaucrat.SwaggerSlateMarkdownWriter.html#write_authentication/2","title":"Bureaucrat.SwaggerSlateMarkdownWriter.write_authentication/2","type":"function","doc":"Writes the authentication details to the given file. This corresponds to the securityDefinitions section of the swagger document."},{"ref":"Bureaucrat.SwaggerSlateMarkdownWriter.html#write_example/2","title":"Bureaucrat.SwaggerSlateMarkdownWriter.write_example/2","type":"function","doc":"Writes a single request/response example to file"},{"ref":"Bureaucrat.SwaggerSlateMarkdownWriter.html#write_headers/2","title":"Bureaucrat.SwaggerSlateMarkdownWriter.write_headers/2","type":"function","doc":"Write the list of request/response headers"},{"ref":"Bureaucrat.SwaggerSlateMarkdownWriter.html#write_model/3","title":"Bureaucrat.SwaggerSlateMarkdownWriter.write_model/3","type":"function","doc":"Writes a single API model schema to the given file. Most of the work is delegated to the write_model_properties/3 recurive function. The example json is output before the table just so slate will align them."},{"ref":"Bureaucrat.SwaggerSlateMarkdownWriter.html#write_model_example/2","title":"Bureaucrat.SwaggerSlateMarkdownWriter.write_model_example/2","type":"function","doc":""},{"ref":"Bureaucrat.SwaggerSlateMarkdownWriter.html#write_model_properties/4","title":"Bureaucrat.SwaggerSlateMarkdownWriter.write_model_properties/4","type":"function","doc":"Writes the fields of the given model to file. prefix is output before each property name to enable nested objects to be flattened."},{"ref":"Bureaucrat.SwaggerSlateMarkdownWriter.html#write_model_property/6","title":"Bureaucrat.SwaggerSlateMarkdownWriter.write_model_property/6","type":"function","doc":""},{"ref":"Bureaucrat.SwaggerSlateMarkdownWriter.html#write_models/2","title":"Bureaucrat.SwaggerSlateMarkdownWriter.write_models/2","type":"function","doc":"Writes the API request/response model schemas to the given file. This corresponds to the definitions section of the swagger document. Each top level definition will be written as a table. Nested objects are flattened out to reduce the number of tables being produced."},{"ref":"Bureaucrat.SwaggerSlateMarkdownWriter.html#write_operations_for_tag/4","title":"Bureaucrat.SwaggerSlateMarkdownWriter.write_operations_for_tag/4","type":"function","doc":"Writes the API details and exampels for operations having the given tag. tag roughly corresponds to a phoenix controller, eg &quot;Users&quot; records_by_operation_id are the examples collected during tests, grouped by operationId (Controller.action)"},{"ref":"Bureaucrat.SwaggerSlateMarkdownWriter.html#write_overview/2","title":"Bureaucrat.SwaggerSlateMarkdownWriter.write_overview/2","type":"function","doc":"Writes the document title and api summary description. This corresponds to the info section of the swagger document."},{"ref":"Bureaucrat.SwaggerSlateMarkdownWriter.html#write_parameters/3","title":"Bureaucrat.SwaggerSlateMarkdownWriter.write_parameters/3","type":"function","doc":"Writes the parameters table for given swagger operation to file. Uses the vendor extension &quot;x-example&quot; to provide example of each parameter. TODO: detailed schema validation rules aren&#39;t shown yet (min/max/regex/etc...)"},{"ref":"Bureaucrat.SwaggerSlateMarkdownWriter.html#write_responses/2","title":"Bureaucrat.SwaggerSlateMarkdownWriter.write_responses/2","type":"function","doc":"Writes the responses table for given swagger operation to file. Swagger only allows a single description per status code, which can be limiting when trying to describe all possible error responses. To work around this, add markdown links into the description."},{"ref":"Bureaucrat.Util.html","title":"Bureaucrat.Util","type":"module","doc":"Some functions used across Bureaucrat internally"},{"ref":"Bureaucrat.Util.html#stable_group_by/3","title":"Bureaucrat.Util.stable_group_by/3","type":"function","doc":"Takes a list of pre-sorted entries and groups them by given function, but returns a list of tuples [{k, v}, ...] instead of a Map to preserve key sort order, which can be given to Enum functions identically. Implementation inspired by Enum.group_by/3 -&gt; https://github.com/elixir-lang/elixir/blob/v1.4.2/lib/elixir/lib/enum.ex#L1036"}]